From d601bc58325aebbd7c798f081392e8d3b74e4452 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Feb 09 2017 15:58:10 +0000
Subject: [PATCH 736/1001] Fix compatibility with Python 2


---

diff --git a/hubs/tests/test_widget_base.py b/hubs/tests/test_widget_base.py
index fd6b3b3..bc8a166 100644
--- a/hubs/tests/test_widget_base.py
+++ b/hubs/tests/test_widget_base.py
@@ -43,7 +43,7 @@ class WidgetTest(APPTest):
         test_widget = LocalTestWidget()
         self.assertRaisesRegexp(
             AttributeError, '.* "name" .*', test_widget.validate)
-        test_widget.name = "învalid næme"
+        test_widget.name = "invalid name \xe2\x98\xba"
         self.assertRaisesRegexp(
             AttributeError, '^Invalid widget name: ', test_widget.validate)
         test_widget.name = "localtest"
diff --git a/hubs/tests/test_widget_caching.py b/hubs/tests/test_widget_caching.py
index 967db0e..c04ba76 100644
--- a/hubs/tests/test_widget_caching.py
+++ b/hubs/tests/test_widget_caching.py
@@ -37,9 +37,10 @@ class CachedFunctionTest(APPTest):
         super(CachedFunctionTest, self).tearDown()
 
     def test_get_cache_key(self):
+        value = "%d|DummyFunction" % self.w_instance.idx
         self.assertEqual(
             self.fn.get_cache_key(),
-            b"%d|DummyFunction" % self.w_instance.idx
+            value.encode("ascii"),
             )
 
     def test_result_cached(self):
diff --git a/hubs/widgets/base.py b/hubs/widgets/base.py
index 9123a4d..824e34d 100644
--- a/hubs/widgets/base.py
+++ b/hubs/widgets/base.py
@@ -5,6 +5,7 @@ import logging
 import re
 import flask
 import jinja2
+import six
 
 from importlib import import_module
 from .caching import CachedFunction
@@ -129,6 +130,10 @@ class Widget(object):
         """
         for view_name, view_class in self.get_views().items():
             endpoint = "%s_%s" % (self.name, view_name)
+            if six.PY2:
+                # Flask will set the __name__ property, which must be a
+                # bytestring on PY2
+                endpoint = endpoint.encode("ascii", "replace")
             view_func = view_class.as_view(endpoint, self)
             for url_rule in view_class.url_rules:
                 rule = "/<hub>/w/%s/<int:idx>/%s" % (
diff --git a/hubs/widgets/registry.py b/hubs/widgets/registry.py
index 006eced..db463b3 100644
--- a/hubs/widgets/registry.py
+++ b/hubs/widgets/registry.py
@@ -1,5 +1,7 @@
 from __future__ import unicode_literals
 
+import six
+
 from importlib import import_module
 from six.moves import UserDict
 from hubs.widgets.base import Widget
@@ -66,3 +68,8 @@ class WidgetRegistry(UserDict):
         """
         for widget in self.values():
             widget.register_routes(app)
+
+    # IterableUserDict is in Python2 but not exported by six.
+    if six.PY2:
+        def __iter__(self):
+            return iter(self.data)

